## canorus 0.7

=== CMakeLists.txt ===
# The name of our project is "Canorus".  CMakeLists files in this project can
# refer to the root source directory of the project as ${CANORUS_SOURCE_DIR}
# and to the root binary directory of the project as ${CANORUS_BINARY_DIR}.
PROJECT(Canorus)

# Don't build anything unless the version of CMake is high enough.
cmake_minimum_required(VERSION 2.6)

# Disable ruby support by default
SET(NO_RUBY 1)

# Enable make uninstall rule
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# Set MingW bin dir, if MingW present
IF(MINGW)
	STRING(REGEX REPLACE "([^ ]+)[/\\].*" "\\1" MINGW_BIN_DIR "${CMAKE_CXX_COMPILER}")
	STRING(REGEX REPLACE "\\\\" "/" MINGW_BIN_DIR "${MINGW_BIN_DIR}") # Replace back slashes to slashes
ENDIF(MINGW)

# Set Qt4 bin dir to find QtCore4.dll and other libs to install
STRING(REGEX REPLACE "([^ ]+)[/\\].*" "\\1" QT_BIN_DIR "${QT_QMAKE_EXECUTABLE}")
STRING(REGEX REPLACE "\\\\" "/" QT_BIN_DIR "${QT_BIN_DIR}")  # Replace back slashes to slashes

#-----------------------------------------------------------------------------
# Canorus version number.
FILE(READ VERSION CANORUS_VERSION)
STRING(REGEX REPLACE "\n" "" CANORUS_VERSION "${CANORUS_VERSION}") # get rid of the newline at the end

# Set default install path:
# In *nix environments this is /usr/local 
# Under M$ Windows this is C:\Program files\Canorus 
# On Mac OS X it is /Applications for the .app and /Library/Fonts for the fonts, but see note below
IF(MINGW)
	IF (NOT CMAKE_INSTALL_PREFIX)
		SET(CMAKE_INSTALL_PREFIX "C:/Program files/Canorus")
	ENDIF (NOT CMAKE_INSTALL_PREFIX)
	SET(CANORUS_INSTALL_DATA_DIR "")
	SET(CANORUS_INSTALL_BIN_DIR "")
	SET(CANORUS_INSTALL_LIB_DIR "")

ELSE(MINGW)
IF(APPLE)
	# This is where OSX-specific resources and scripts live.
	SET(CANORUS_OSX_DIR ${CMAKE_CURRENT_BINARY_DIR}/macosx)

	# "make install" will always install to macosx/package-contents,
	# regardless of any -DCMAKE_INSTALL_PREFIX=foo
	# To install locally, build a package and use the OSX installer
	# TODO: integrate packaging script into CMake so we can just do "make install"
	# or similar and have it install and link the libraries properly
	SET(CMAKE_INSTALL_PREFIX "${CANORUS_OSX_DIR}/package-contents")

	SET(CANORUS_OSX_APP_DIR "Canorus.app/Contents")
	
	SET(CANORUS_INSTALL_BIN_DIR ${CANORUS_OSX_APP_DIR}/MacOS)
	SET(CANORUS_INSTALL_DATA_DIR ${CANORUS_OSX_APP_DIR}/Resources)
	SET(CANORUS_INSTALL_LIB_DIR ${CANORUS_OSX_APP_DIR}/Resources/lib)
ELSE(APPLE)
	IF (NOT CMAKE_INSTALL_PREFIX)
		SET(CMAKE_INSTALL_PREFIX "/usr/local")
	ENDIF (NOT CMAKE_INSTALL_PREFIX)
	SET(CANORUS_INSTALL_DATA_DIR "share/canorus")
	SET(CANORUS_INSTALL_BIN_DIR "bin")
	SET(CANORUS_INSTALL_LIB_DIR "lib")
ENDIF(APPLE)
ENDIF(MINGW)

#-----------------------------------------------------------------------------
# Search for Qt4. We need the latest version of Qt
SET(QT_MIN_VERSION "4.4.0")

# this line includes FindQt4.cmake, which searches the Qt library and headers
FIND_PACKAGE(Qt4 REQUIRED)

# in the following lines all the requires include directories are added
INCLUDE_DIRECTORIES(src)
INCLUDE_DIRECTORIES(src/zlib)

# Recurse into the "src" and "doc" subdirectories.  This does not actually
# cause another cmake executable to run.  The same process will walk through
# the project's entire directory structure.
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(doc)

# Install README, VERSION, LICENSE.GPL and other raw txt files
INSTALL(FILES AUTHORS DEVELOPERS LICENSE.GPL NEWS README VERSION DESTINATION "${CMAKE_INSTALL_PREFIX}/${CANORUS_INSTALL_DATA_DIR}")

=== src/CMakeLists.txt ===
# Define Sources of this Canorus directory

INCLUDE(CheckLibraryExists)
FIND_PACKAGE(Qt4)

# This module is used to resolve the file dependencies
# for QT files using an UI (User Unterface) Qt file
# created with the Qt4 designer
# INCLUDE(AddFileDependencies)

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g")

# Build universal binaries on Mac
IF(APPLE)
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch ppc -arch i386")
	SET(DEFAULT_DATA_DIR "Canorus.app/Contents/Resources")
ENDIF(APPLE)

#######################
# Scripting detection #
#######################
# The following lines detect scripting environments (SWIG, Ruby, Python etc.)
FIND_PACKAGE(SWIG QUIET)
IF(SWIG_FOUND AND NOT NO_SWIG)
	SET(USE_SWIG True)
	MESSAGE("SWIG found, using scripting extensions.")
ELSE(SWIG_FOUND AND NOT NO_SWIG)
	MESSAGE("SWIG *not* found, disabling SWIG!")
	SET(NO_RUBY True)
	SET(NO_PYTHON True)
ENDIF(SWIG_FOUND AND NOT NO_SWIG)

FIND_PACKAGE(Ruby)	#Setup RUBY_INCLUDE_PATH and RUBY_LIBRARIES
IF(RUBY_INCLUDE_PATH AND NOT NO_RUBY)
	MESSAGE("Ruby Library and Development files found. Ruby extensions enabled.")
	SET(USE_RUBY True)
    # Create empty file as needed so build does not stop here		
	FILE(APPEND ${CMAKE_CURRENT_SOURCE_DIR}/scripting/canorusrubyRUBY_wrap.cxx "")
ELSE(RUBY_INCLUDE_PATH AND NOT NO_RUBY)
	MESSAGE("Ruby Library and Development files *not* found. Ruby extensions disabled!")
	SET(RUBY_LIBRARY "")
ENDIF(RUBY_INCLUDE_PATH AND NOT NO_RUBY)

FIND_PACKAGE(PythonLibs)
IF(PYTHON_INCLUDE_PATH AND NOT NO_PYTHON)
	MESSAGE("Python Library and Development files found. Python extensions enabled.")
	# PYTHON_LIBRARY points to C:\PythonXY\pythonXY.dll
	# PYTHON_LIB should point to C:\PythonXY\Lib
	STRING(REGEX REPLACE "([^ ]+)[/\\].*" "\\1" PYTHON_LIB "${PYTHON_LIBRARY}") # remove pythonXY.dll
	STRING(REGEX REPLACE "\\\\" "/" PYTHON_LIB "${PYTHON_LIB}")  # Replace back slashes to slashes
	SET( PYTHON_LIB "${PYTHON_LIB}/Lib/" ) # add /Lib/

	# Needed on some Linux distros (SuSE, Gentoo) to prevent linking issues (openpty, forkpty) 
	CHECK_LIBRARY_EXISTS(util openpty "" HAVE_OPENPTY)
	IF("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
		IF (HAVE_OPENPTY)
			SET(PYTHON_LIBRARY ${PYTHON_LIBRARY} util)
		ENDIF (HAVE_OPENPTY)
	ENDIF("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
	
	SET(USE_PYTHON True)
ELSE(PYTHON_INCLUDE_PATH AND NOT NO_PYTHON)
	MESSAGE("Python Library and Development files *not* found. Python extensions disabled!")
	SET(PYTHON_LIBRARY "")
ENDIF(PYTHON_INCLUDE_PATH AND NOT NO_PYTHON)

##################################
# Poppler detection for printing #
##################################
#FIND_PATH(POPPLER_INCLUDE_PATH 
#	NAMES	poppler-config.h
#	PATH_SUFFIXES poppler
# )
#FIND_LIBRARY(POPPLER_LIBRARY NAMES poppler )
#FIND_LIBRARY(POPPLERQT4_LIBRARY NAMES poppler-qt4)
#IF(POPPLER_INCLUDE_PATH AND POPPLER_LIBRARY AND POPPLERQT4_LIBRARY)
#	MESSAGE("Poppler Libraries found. Printing enabled.")
#	MESSAGE("Include path: ${POPPLER_INCLUDE_PATH}" )
#	SET(USE_POPPLER True)
#	SET(POPPLER_SOURCE control/printctl.cpp)
#	SET(POPPLER_HEADER control/printctl.h)
#ELSE(POPPLER_INCLUDE_PATH AND POPPLER_LIBRARY AND POPPLERQT4_LIBRARY)
#	MESSAGE("Poppler Library and Development files *not* found. Printing disabled!")
#	MESSAGE("Path ${POPPLER_INCLUDE_PATH}, Lib ${POPPLER_LIBRARIES}")
#	SET(POPPLER_LIBRARY "")
#	SET(POPPLER_INCLUDE_PATH "")
#	SET(POPPLERQT4_LIBRARY "")
#	SET(POPPLER_SOURCE "")
#	SET(POPPLER_HEADER "")
#ENDIF(POPPLER_INCLUDE_PATH AND POPPLER_LIBRARY AND POPPLERQT4_LIBRARY)

# Set ZLib sources on windows
FILE(GLOB ZLIB_Srcs "zlib/*.c")

##############################
# List of Qt4-parsed sources #
##############################
# Define the UI source files used by Canorus
SET(Canorus_UIs		# List of .ui forms drawn by qt-designer that need to be compiled
	ui/mainwin.ui
	ui/settingsdialog.ui
	
	ui/propertiesdialog.ui
	ui/documentproperties.ui
	ui/sheetproperties.ui
	ui/staffproperties.ui
	ui/voiceproperties.ui
	ui/lyricscontextproperties.ui
	ui/functionmarkcontextproperties.ui
	
	ui/midirecorder.ui
	ui/transposeview.ui
)

# Define the MOC source files used by Canorus
SET(Canorus_Gui_MOCs	# List of classes which Qt needs to produce MOCs for them (in order for events, signals, slots and other macros to work)
	core/autorecovery.h
	
	ui/mainwin.h
	ui/settingsdialog.h
	ui/propertiesdialog.h
	ui/transposeview.h
	
	widgets/lcdnumber.h
	widgets/viewport.h
	widgets/viewportcontainer.h
	widgets/scoreviewport.h
	widgets/sourceviewport.h
	widgets/toolbutton.h
	widgets/toolbuttonpopup.h
	widgets/menutoolbutton.h
	widgets/undotoolbutton.h
	widgets/pyconsole.h
	widgets/midirecorderview.h
	widgets/resourceview.h
	widgets/helpbrowser.h
	
	control/previewctl.h
	control/printctl.h
)

SET(Canorus_Core_MOCs # MOCs compiled into scripting library as well
	import/import.h
	export/export.h
	export/pdfexport.h
	export/svgexport.h

	control/externprogram.h
	control/typesetctl.h
	
	interface/mididevice.h
	interface/playback.h
	core/midirecorder.h

	interface/pluginaction.h
)

################
# Qt4 settings #
################
# Enable needed Qt modules for Canorus
SET(QT_USE_QTXML True) # Save/Load
SET(QT_USE_QTSVG True) # Icons, Images etc.
SET(QT_USE_QTHELP True) # Inline help browser
SET(QT_USE_QTWEBKIT True) # Inline help browser

# Add all resources to Canorus_Resrcs (icons, html files etc.)
#SET(Canorus_Resrcs ui/mainwin.qrc) # not needed, all resources are loaded on-the-fly

# Add all the dependencies needed for the MainWindow
# add_file_dependencies( ui/mainwin.cpp ui/ui_mainwin.h )

# This scripts runs the resource compiler rcc.
# The result of it is stored into Canorus_Resrcs_Srcs
# variable. This has to be included later in the
# add_executable line.
QT4_ADD_RESOURCES(Canorus_Resrcs_Srcs ${Canorus_Resrcs})

# This scripts runs the user interface compiler uic.
# The result of it is stored into Canorus_UIC_Srcs
# variable. This has to be included later in the
# add_executable line.
QT4_WRAP_UI(Canorus_UIC_Srcs ${Canorus_UIs})

# This script runs the meta object compiler moc.
# The result of it is stored into Canorus_Gui_MOC_Srcs and Canorus_Core_MOC_Srcs
# variable. This has to be included later in the
# add_executable line.
QT4_WRAP_CPP(Canorus_Gui_MOC_Srcs ${Canorus_Gui_MOCs})
QT4_WRAP_CPP(Canorus_Core_MOC_Srcs ${Canorus_Core_MOCs})

#########################
# List of other sources #
#########################
SET(Canorus_Core_Srcs		# Core sources - data part of the MVC model
	core/settings.cpp
	core/undocommand.cpp
	core/undo.cpp
	core/autorecovery.cpp
	core/mimedata.cpp
	core/file.cpp
	core/fileformats.cpp
	core/typesetter.cpp
	core/tar.cpp
	core/archive.cpp
	core/resource.cpp
	core/midirecorder.cpp
	
	core/playablelength.cpp
	core/diatonicpitch.cpp
	core/interval.cpp
	core/diatonickey.cpp
	core/transpose.cpp
	
	core/document.cpp
	core/sheet.cpp
	core/context.cpp
	core/staff.cpp
	core/functionmarkcontext.cpp
	core/lyricscontext.cpp
	
	core/muselement.cpp
	core/muselementfactory.cpp
	core/voice.cpp
	core/barline.cpp
	core/clef.cpp
	core/keysignature.cpp
	core/timesignature.cpp
	core/playable.cpp
	core/note.cpp
	core/slur.cpp
	core/tuplet.cpp
	core/rest.cpp
	
	core/mark.cpp
	core/articulation.cpp
	core/fermata.cpp
	core/repeatmark.cpp
	core/tempo.cpp
	core/ritardando.cpp
	core/text.cpp
	core/bookmark.cpp
	core/fingering.cpp
	core/dynamic.cpp
	core/crescendo.cpp
	core/instrumentchange.cpp
	
	core/syllable.cpp
	
	core/functionmark.cpp
)

SET(Canorus_Scripting_Srcs	# Sources meant for bridging C++<->scripting language
	scripting/swigruby.cpp
	scripting/swigpython.cpp
)

SET(Canorus_Widget_Srcs  	# Sources for all custom widgets present in Canorus
	widgets/lcdnumber.cpp
	widgets/scoreviewport.cpp
	widgets/sourceviewport.cpp
	widgets/toolbutton.cpp
	widgets/toolbuttonpopup.cpp
	widgets/menutoolbutton.cpp
	widgets/undotoolbutton.cpp
	widgets/viewport.cpp
	widgets/viewportcontainer.cpp
	widgets/pyconsole.cpp
	widgets/midirecorderview.cpp
	widgets/resourceview.cpp
	widgets/helpbrowser.cpp
)

SET(Canorus_Ui_Srcs		# Implementations of widgets that have their own .ui qt-designer files
	ui/mainwin.cpp
	ui/settingsdialog.cpp
	ui/propertiesdialog.cpp
	ui/transposeview.cpp
)

SET(Canorus_Gui_Ctl_Srcs       # Control instances for user interface or views 
	control/previewctl.cpp
	control/printctl.cpp
	control/helpctl.cpp
)

SET(Canorus_Ctl_Srcs            # Control instances for user interface or views and core
	control/externprogram.cpp
	control/typesetctl.cpp
	control/resourcectl.cpp
)

SET(Canorus_Drawable_Srcs	# Drawable instances of the data
	drawable/drawable.cpp

	drawable/drawablecontext.cpp
	drawable/drawablestaff.cpp
	drawable/drawablelyricscontext.cpp
	drawable/drawablefunctionmarkcontext.cpp

	drawable/drawablemuselement.cpp
	drawable/drawablenote.cpp
	drawable/drawableslur.cpp
	drawable/drawabletuplet.cpp
	drawable/drawablerest.cpp
	drawable/drawableaccidental.cpp
	drawable/drawableclef.cpp
	drawable/drawablekeysignature.cpp
	drawable/drawabletimesignature.cpp
	drawable/drawablebarline.cpp
	drawable/drawablemark.cpp
	drawable/drawablesyllable.cpp
	drawable/drawablefunctionmark.cpp
)

SET(Canorus_Interface_Srcs	# Other interfaces like Engraver, Playback, Plugin manager and others belong here.
	interface/engraver.cpp
	interface/playback.cpp
	interface/rtmididevice.cpp
	interface/mididevice.cpp
	interface/pluginmanager.cpp
	interface/pluginaction.cpp
	interface/plugin.cpp
	interface/keybdinput.cpp

	interface/pyconsoleinterface.cpp
)

SET(Canorus_Export_Srcs     # Classes for exporting Canorus data to various file formats
	export/export.cpp
	export/midiexport.cpp
	export/lilypondexport.cpp
	export/canorusmlexport.cpp
	export/canexport.cpp
	export/musicxmlexport.cpp
	export/pdfexport.cpp
	export/svgexport.cpp
)

SET(Canorus_Import_Srcs     # Classes for import various file formats to Canorus data
	import/import.cpp
	import/lilypondimport.cpp
	import/midiimport.cpp
	import/canorusmlimport.cpp
	import/canimport.cpp
	import/musicxmlimport.cpp
)

SET(Canorus_RtMidi_Srcs		# RtMIDI library
	rtmidi/RtMidi.cpp
)

SET(Canorus_Srcs
	main.cpp
	canorus.cpp
	
	${Canorus_Core_Srcs}
	${Canorus_Ctl_Srcs}
	${Canorus_Gui_Ctl_Srcs}
	${Canorus_Scripting_Srcs}
	${Canorus_Drawable_Srcs}
	${Canorus_Ui_Srcs}
	${Canorus_Interface_Srcs}
	${Canorus_Export_Srcs}
	${Canorus_Import_Srcs}
	${Canorus_RtMidi_Srcs}
	${Canorus_Widget_Srcs}
)

SET(Canorus_Swig_Srcs	# Sources which Swig needs to build its Python/Ruby module.
	core/document.cpp
	core/sheet.cpp
	core/context.cpp
	core/staff.cpp
	core/lyricscontext.cpp
	core/functionmarkcontext.cpp

	core/muselement.cpp
	core/voice.cpp
	core/barline.cpp
	core/clef.cpp
	core/keysignature.cpp
	core/timesignature.cpp
	core/playable.cpp
	core/note.cpp
	core/slur.cpp
	core/tuplet.cpp
	core/rest.cpp
	
	core/playablelength.cpp
	core/diatonicpitch.cpp
	core/interval.cpp
	core/diatonickey.cpp
	core/transpose.cpp
	
	core/mark.cpp
	core/articulation.cpp
	core/fermata.cpp
	core/repeatmark.cpp
	core/tempo.cpp
	core/ritardando.cpp
	core/text.cpp
	core/bookmark.cpp
	core/fingering.cpp
	core/dynamic.cpp
	core/crescendo.cpp
	core/instrumentchange.cpp

	core/syllable.cpp
	
	core/functionmark.cpp
	
	core/settings.cpp
	core/file.cpp
	core/tar.cpp
	core/archive.cpp
	core/resource.cpp
	core/midirecorder.cpp
	core/typesetter.cpp
	${Canorus_Import_Srcs}
	${Canorus_Export_Srcs}
	${Canorus_Ctl_Srcs}
	${Canorus_RtMidi_Srcs}
	interface/rtmididevice.cpp
	interface/mididevice.cpp
	interface/playback.cpp

	interface/pyconsoleinterface.cpp
	interface/plugin.cpp
	interface/pluginaction.cpp
	interface/pluginmanager.cpp
#	interface/plugins_swig.cpp
	scripting/swigpython.cpp
	scripting/swigruby.cpp
	${Canorus_Core_MOC_Srcs}
)
IF(MINGW) # Append ZLIB srcs to Swig srcs on Windows
	SET( Canorus_Swig_Srcs ${Canorus_Swig_Srcs} ${ZLIB_Srcs} )
ENDIF(MINGW)

SET( Canorus_Scripts "scripts" ) # Official scripts shipped with Canorus.

SET( Canorus_Plugins "plugins" ) # Official plug-ins shipped with Canorus.

SET( Canorus_Images "ui/images" )

=== doc/usersguide/Makefile ===
all: pdf html qthelp

tex:
	lyx -e latex *.lyx

pdf: tex
	for i in *.tex; do pdflatex $$i; done
	for i in *.tex; do pdflatex $$i; done # TOC

html: tex
	for i in *.tex; do htlatex $$i; done

qthelp: html
	for i in *.qhcp; do qcollectiongenerator $$i; done

clean: clean-tex clean-html clean-pdf clean-qthelp

clean-tex:
	rm -f *.tex images/*.eps

clean-pdf:
	rm -f *.log *.aux *.pdf

clean-html:
	rm -f *.4ct *.4tc *.aux *.css *.dvi *.html *.idv *.lg *.log *.tmp *.xref *.png *.toc

clean-qthelp:
	rm -f *.qhc *.qch

=== debian/changelog ===
canorus (0.7-2ubuntu1) natty; urgency=low

  * New patch 70-no-add-needed: add missing libraries to fix FTBFS.

 -- Ilya Barygin <barygin@gmail.com>  Sat, 08 Jan 2011 19:27:03 +0300

canorus (0.7-2) unstable; urgency=low

  * Convert to dpkg source format 3.0 (quilt) and remove quilt from
    Build-Depends
  * Build-Depend on libasound2-dev instead of libasound-dev
  * Convert clogosm.png again to 16x16 and 32x32 xpm images, something
    went wrong the first time
  * debian/patches:
    - Remove 50-fix-working-directory-for-lilypond, it's no longer
      needed with lilypond >= 2.12
    - Add 60-complete-desktop-file to add more information to
      upstream's canorus.desktop file
  * Install canorus.desktop file to provide a menu entry in KDE and
    GNOME. Closes: #557705
  * Update Standards-Version to 3.8.3, no changes needed

 -- Tobias Quathamer <toddy@debian.org>  Thu, 26 Nov 2009 16:53:27 +0100

canorus (0.7-1) unstable; urgency=low

  * Initial release (Closes: #461914)

 -- Tobias Quathamer <toddy@debian.org>  Tue, 31 Mar 2009 11:29:13 +0200

=== debian/control ===
Source: canorus
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Tobias Quathamer <toddy@debian.org>
Build-Depends: debhelper (>= 7), cmake, libasound2-dev, libqt4-dev,
 zlib1g-dev
Standards-Version: 3.8.3
Homepage: http://www.canorus.org/

Package: canorus
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, canorus-data
Recommends: lilypond
Suggests: timidity | fluidsynth
Description: graphical music score editor
 Canorus is a graphical music score editor written for the Qt4 toolkit.
 It is a sequel of the well-known music score editor for Linux, NoteEdit.
 Canorus uses LilyPond for music engraving to achieve a very high quality
 in the resulting documents.
 .
 Canorus offers a number of import and export filters for LilyPond,
 MusicXML, Midi, NoteEdit and others.

Package: canorus-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ttf-freefont
Recommends: canorus
Description: data files for canorus, a graphical music score editor
 Canorus is a graphical music score editor written for the Qt4 toolkit.
 It is a sequel of the well-known music score editor for Linux, NoteEdit.
 Canorus uses LilyPond for music engraving to achieve a very high quality
 in the resulting documents.
 .
 Canorus offers a number of import and export filters for LilyPond,
 MusicXML, Midi, NoteEdit and others.
 .
 This package contains architecture independent data files for canorus.

=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_VERSION=0.7.R1002
PACKAGE_VERSION=0.7
get-orig-source:
	rm -rf canorus-$(PACKAGE_VERSION)/
	tar xjf canorus_$(UPSTREAM_VERSION)_source.tar.bz2
	# Most importantly, remove upstream's debian directory
	find canorus-$(UPSTREAM_VERSION)/ -type d -name "debian" | xargs rm -rf
	# Remove upstream's building information
	find canorus-$(UPSTREAM_VERSION)/ -type d -name "\.settings" | xargs rm -rf
	find canorus-$(UPSTREAM_VERSION)/ -type d -name "\.externalToolBuilders" | xargs rm -rf
	find canorus-$(UPSTREAM_VERSION)/ -type f -name "\.*project" | xargs rm -rf
	# Remove files for different platforms
	find canorus-$(UPSTREAM_VERSION)/ -type d -name "windows" | xargs rm -rf
	find canorus-$(UPSTREAM_VERSION)/ -type d -name "macosx" | xargs rm -rf
	# Remove zlib directory
	find canorus-$(UPSTREAM_VERSION)/ -type d -name "zlib" | xargs rm -rf
	mv canorus-$(UPSTREAM_VERSION)/ canorus-$(PACKAGE_VERSION)/
	tar czf canorus_$(PACKAGE_VERSION).orig.tar.gz canorus-$(PACKAGE_VERSION)/

# TODO: Provide a target to re-create the xpm pixmap for the menu
# This requires gm to be installed
create-menu-pixmap:
	# This does not work, the pixmaps are generated by hand with gimp
	#gm convert -resize 32x32 src/ui/images/clogosm.png debian/canorus-32x32.xpm
	#gm convert -resize 16x16 src/ui/images/clogosm.png debian/canorus-16x16.xpm

build:
	dh_testdir
	cmake . -DCMAKE_INSTALL_PREFIX="/usr" -DNO_RUBY=1 -DNO_PYTHON=1
	make

clean:
	dh clean
	# Preserve handwritten Makefiles during clean
	mv doc/usersguide/Makefile doc/usersguide/Makefile.upstream
	mv doc/developersguide/Makefile doc/developersguide/Makefile.upstream
	# Remove left over files from upstream (there is no distclean target)
	find -type f -name "*\.qm" | xargs rm -f
	find -type f -name "*\.cmake" | xargs rm -f
	find -type f -name "Makefile" | xargs rm -f
	find -type f -name "CMakeCache\.txt" | xargs rm -f
	find -type f -name "install_manifest\.txt" | xargs rm -f
	find -type d -name "CMakeFiles" | xargs rm -rf
	# Restore handwritten Makefiles after clean
	mv doc/usersguide/Makefile.upstream doc/usersguide/Makefile
	mv doc/developersguide/Makefile.upstream doc/developersguide/Makefile

install: build
	dh_testdir
	make DESTDIR=$(CURDIR)/debian/tmp install
	dh install --before dh_installchangelogs
	dh_installchangelogs NEWS
	dh install --before dh_link
	# Correct location of example files
	mv $(CURDIR)/debian/canorus/usr/share/doc/canorus/examples/examples/* \
	$(CURDIR)/debian/canorus/usr/share/doc/canorus/examples
	rm -rf $(CURDIR)/debian/canorus/usr/share/doc/canorus/examples/examples/
	# Copy the .desktop file, upstream misses that
	cp canorus.desktop $(CURDIR)/debian/canorus/usr/share/applications/
	# Remove FreeSans.ttf, the package depends on ttf-freefont
	rm -rf $(CURDIR)/debian/canorus-data/usr/share/canorus/fonts/FreeSans.ttf
	dh install --remaining

# Build architecture-independent files here.
binary-indep: install
	dh $@

# Build architecture-dependent files here.
binary-arch: install
	dh $@

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
# See uscan(1) for format
# Compulsory line, this is a version 3 file
version=3
opts="uversionmangle=s/\.R[0-9]+//;s/([0-9])([a-zA-Z])+/$1~$2/" \
http://download.berlios.de/canorus/canorus_(.*)_source\.tar\.bz2

## canorus 0.7+dfsg+svn1256

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,23 @@
 # Define Sources of this Canorus directory
 
 INCLUDE(CheckLibraryExists)
+
 FIND_PACKAGE(Qt4)
 
 # This module is used to resolve the file dependencies
-# for QT files using an UI (User Unterface) Qt file
+# for QT files using an UI (User Interface) Qt file
 # created with the Qt4 designer
 # INCLUDE(AddFileDependencies)
 
-SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g")
+IF(NOT CMAKE_BUILD_TYPE)
+	SET(CMAKE_BUILD_TYPE Debug)
+ENDIF(NOT CMAKE_BUILD_TYPE)
+
+SET(CMAKE_C_FLAGS_DEBUG "-O0 -g")
+SET(CMAKE_C_FLAGS_RELEASE "-O2")
+
+SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}")
+SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
 
 # Build universal binaries on Mac
 IF(APPLE)
@@ -42,7 +51,7 @@
 ENDIF(RUBY_INCLUDE_PATH AND NOT NO_RUBY)
 
 FIND_PACKAGE(PythonLibs)
-IF(PYTHON_INCLUDE_PATH AND NOT NO_PYTHON)
+IF(PYTHON_INCLUDE_DIRS AND NOT NO_PYTHON)
 	MESSAGE("Python Library and Development files found. Python extensions enabled.")
 	# PYTHON_LIBRARY points to C:\PythonXY\pythonXY.dll
 	# PYTHON_LIB should point to C:\PythonXY\Lib
@@ -59,10 +68,10 @@
 	ENDIF("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
 	
 	SET(USE_PYTHON True)
-ELSE(PYTHON_INCLUDE_PATH AND NOT NO_PYTHON)
+ELSE(PYTHON_INCLUDE_DIRS AND NOT NO_PYTHON)
 	MESSAGE("Python Library and Development files *not* found. Python extensions disabled!")
 	SET(PYTHON_LIBRARY "")
-ENDIF(PYTHON_INCLUDE_PATH AND NOT NO_PYTHON)
+ENDIF(PYTHON_INCLUDE_DIRS AND NOT NO_PYTHON)
 
 ##################################
 # Poppler detection for printing #
@@ -115,17 +124,20 @@
 # Define the MOC source files used by Canorus
 SET(Canorus_Gui_MOCs	# List of classes which Qt needs to produce MOCs for them (in order for events, signals, slots and other macros to work)
 	core/autorecovery.h
+
+	scoreui/keysignatureui.h
 	
 	ui/mainwin.h
 	ui/settingsdialog.h
 	ui/propertiesdialog.h
 	ui/transposeview.h
-	
+	ui/singleaction.h
+
 	widgets/lcdnumber.h
-	widgets/viewport.h
-	widgets/viewportcontainer.h
-	widgets/scoreviewport.h
-	widgets/sourceviewport.h
+	widgets/view.h
+	widgets/viewcontainer.h
+	widgets/scoreview.h
+	widgets/sourceview.h
 	widgets/toolbutton.h
 	widgets/toolbuttonpopup.h
 	widgets/menutoolbutton.h
@@ -134,9 +146,15 @@
 	widgets/midirecorderview.h
 	widgets/resourceview.h
 	widgets/helpbrowser.h
+	widgets/actionseditor.h
+	widgets/progressstatusbar.h
+	widgets/tabwidget.h
 	
 	control/previewctl.h
 	control/printctl.h
+	control/mainwinprogressctl.h
+
+	scorectl/keysignaturectl.h
 )
 
 SET(Canorus_Core_MOCs # MOCs compiled into scripting library as well
@@ -192,7 +210,7 @@
 #########################
 # List of other sources #
 #########################
-SET(Canorus_Core_Srcs		# Core sources - data part of the MVC model
+SET(Canorus_Core_Srcs		# Core sources
 	core/settings.cpp
 	core/undocommand.cpp
 	core/undo.cpp
@@ -203,51 +221,57 @@
 	core/typesetter.cpp
 	core/tar.cpp
 	core/archive.cpp
-	core/resource.cpp
 	core/midirecorder.cpp
-	
-	core/playablelength.cpp
-	core/diatonicpitch.cpp
-	core/interval.cpp
-	core/diatonickey.cpp
+	core/muselementfactory.cpp
 	core/transpose.cpp
-	
-	core/document.cpp
-	core/sheet.cpp
-	core/context.cpp
-	core/staff.cpp
-	core/functionmarkcontext.cpp
-	core/lyricscontext.cpp
-	
-	core/muselement.cpp
-	core/muselementfactory.cpp
-	core/voice.cpp
-	core/barline.cpp
-	core/clef.cpp
-	core/keysignature.cpp
-	core/timesignature.cpp
-	core/playable.cpp
-	core/note.cpp
-	core/slur.cpp
-	core/tuplet.cpp
-	core/rest.cpp
-	
-	core/mark.cpp
-	core/articulation.cpp
-	core/fermata.cpp
-	core/repeatmark.cpp
-	core/tempo.cpp
-	core/ritardando.cpp
-	core/text.cpp
-	core/bookmark.cpp
-	core/fingering.cpp
-	core/dynamic.cpp
-	core/crescendo.cpp
-	core/instrumentchange.cpp
-	
-	core/syllable.cpp
-	
-	core/functionmark.cpp
+)
+
+SET(Canorus_Score_Srcs		# Score representation
+	score/playablelength.cpp
+	score/diatonicpitch.cpp
+	score/interval.cpp
+	score/diatonickey.cpp
+	
+	score/document.cpp
+	score/resource.cpp
+	score/sheet.cpp
+	score/context.cpp
+	score/staff.cpp
+	score/functionmarkcontext.cpp
+	score/figuredbasscontext.cpp
+	score/lyricscontext.cpp
+	
+	score/muselement.cpp
+	score/voice.cpp
+	score/barline.cpp
+	score/clef.cpp
+	score/keysignature.cpp
+	score/timesignature.cpp
+	score/playable.cpp
+	score/note.cpp
+	score/slur.cpp
+	score/tuplet.cpp
+	score/rest.cpp
+	score/midinote.cpp
+	
+	score/mark.cpp
+	score/articulation.cpp
+	score/fermata.cpp
+	score/repeatmark.cpp
+	score/tempo.cpp
+	score/ritardando.cpp
+	score/text.cpp
+	score/bookmark.cpp
+	score/fingering.cpp
+	score/dynamic.cpp
+	score/crescendo.cpp
+	score/instrumentchange.cpp
+	
+	score/syllable.cpp
+	
+	score/functionmark.cpp
+	
+	score/figuredbassmark.cpp
 )
 
 SET(Canorus_Scripting_Srcs	# Sources meant for bridging C++<->scripting language
@@ -257,18 +281,21 @@
 
 SET(Canorus_Widget_Srcs  	# Sources for all custom widgets present in Canorus
 	widgets/lcdnumber.cpp
-	widgets/scoreviewport.cpp
-	widgets/sourceviewport.cpp
+	widgets/scoreview.cpp
+	widgets/sourceview.cpp
 	widgets/toolbutton.cpp
 	widgets/toolbuttonpopup.cpp
 	widgets/menutoolbutton.cpp
 	widgets/undotoolbutton.cpp
-	widgets/viewport.cpp
-	widgets/viewportcontainer.cpp
+	widgets/view.cpp
+	widgets/viewcontainer.cpp
 	widgets/pyconsole.cpp
 	widgets/midirecorderview.cpp
 	widgets/resourceview.cpp
 	widgets/helpbrowser.cpp
+	widgets/actionseditor.cpp
+	widgets/progressstatusbar.cpp
+	widgets/tabwidget.cpp
 )
 
 SET(Canorus_Ui_Srcs		# Implementations of widgets that have their own .ui qt-designer files
@@ -276,12 +303,18 @@
 	ui/settingsdialog.cpp
 	ui/propertiesdialog.cpp
 	ui/transposeview.cpp
+	ui/singleaction.cpp
+
+	scoreui/keysignatureui.cpp
 )
 
 SET(Canorus_Gui_Ctl_Srcs       # Control instances for user interface or views 
 	control/previewctl.cpp
 	control/printctl.cpp
 	control/helpctl.cpp
+	control/mainwinprogressctl.cpp
+
+	scorectl/keysignaturectl.cpp
 )
 
 SET(Canorus_Ctl_Srcs            # Control instances for user interface or views and core
@@ -290,31 +323,35 @@
 	control/resourcectl.cpp
 )
 
-SET(Canorus_Drawable_Srcs	# Drawable instances of the data
-	drawable/drawable.cpp
-
-	drawable/drawablecontext.cpp
-	drawable/drawablestaff.cpp
-	drawable/drawablelyricscontext.cpp
-	drawable/drawablefunctionmarkcontext.cpp
-
-	drawable/drawablemuselement.cpp
-	drawable/drawablenote.cpp
-	drawable/drawableslur.cpp
-	drawable/drawabletuplet.cpp
-	drawable/drawablerest.cpp
-	drawable/drawableaccidental.cpp
-	drawable/drawableclef.cpp
-	drawable/drawablekeysignature.cpp
-	drawable/drawabletimesignature.cpp
-	drawable/drawablebarline.cpp
-	drawable/drawablemark.cpp
-	drawable/drawablesyllable.cpp
-	drawable/drawablefunctionmark.cpp
+SET(Canorus_Layout_Srcs	# Drawable instances of the data
+	layout/layoutengine.cpp
+	
+	layout/drawable.cpp
+
+	layout/drawablecontext.cpp
+	layout/drawablestaff.cpp
+	layout/drawablelyricscontext.cpp
+	layout/drawablefiguredbasscontext.cpp
+	layout/drawablefunctionmarkcontext.cpp
+
+	layout/drawablemuselement.cpp
+	layout/drawablenote.cpp
+	layout/drawableslur.cpp
+	layout/drawabletuplet.cpp
+	layout/drawablerest.cpp
+	layout/drawablemidinote.cpp
+	layout/drawableaccidental.cpp
+	layout/drawableclef.cpp
+	layout/drawablekeysignature.cpp
+	layout/drawabletimesignature.cpp
+	layout/drawablebarline.cpp
+	layout/drawablemark.cpp
+	layout/drawablesyllable.cpp
+	layout/drawablefiguredbassnumber.cpp
+	layout/drawablefunctionmark.cpp
 )
 
 SET(Canorus_Interface_Srcs	# Other interfaces like Engraver, Playback, Plugin manager and others belong here.
-	interface/engraver.cpp
 	interface/playback.cpp
 	interface/rtmididevice.cpp
 	interface/mididevice.cpp
@@ -350,77 +387,49 @@
 	rtmidi/RtMidi.cpp
 )
 
+SET(Canorus_PMIDI_Srcs		# PMIDI excerpts
+	import/pmidi/glib.c
+	import/pmidi/elements.c
+	import/pmidi/except.c
+	import/pmidi/mdutil.c
+	import/pmidi/midiread.c
+	import/pmidi/wrapper.c
+)
+
 SET(Canorus_Srcs
 	main.cpp
 	canorus.cpp
 	
 	${Canorus_Core_Srcs}
+	${Canorus_Score_Srcs}
 	${Canorus_Ctl_Srcs}
 	${Canorus_Gui_Ctl_Srcs}
 	${Canorus_Scripting_Srcs}
-	${Canorus_Drawable_Srcs}
+	${Canorus_Layout_Srcs}
 	${Canorus_Ui_Srcs}
 	${Canorus_Interface_Srcs}
 	${Canorus_Export_Srcs}
 	${Canorus_Import_Srcs}
 	${Canorus_RtMidi_Srcs}
 	${Canorus_Widget_Srcs}
+	${Canorus_PMIDI_Srcs}
 )
 
 SET(Canorus_Swig_Srcs	# Sources which Swig needs to build its Python/Ruby module.
-	core/document.cpp
-	core/sheet.cpp
-	core/context.cpp
-	core/staff.cpp
-	core/lyricscontext.cpp
-	core/functionmarkcontext.cpp
-
-	core/muselement.cpp
-	core/voice.cpp
-	core/barline.cpp
-	core/clef.cpp
-	core/keysignature.cpp
-	core/timesignature.cpp
-	core/playable.cpp
-	core/note.cpp
-	core/slur.cpp
-	core/tuplet.cpp
-	core/rest.cpp
-	
-	core/playablelength.cpp
-	core/diatonicpitch.cpp
-	core/interval.cpp
-	core/diatonickey.cpp
+	${Canorus_Score_Srcs}
 	core/transpose.cpp
-	
-	core/mark.cpp
-	core/articulation.cpp
-	core/fermata.cpp
-	core/repeatmark.cpp
-	core/tempo.cpp
-	core/ritardando.cpp
-	core/text.cpp
-	core/bookmark.cpp
-	core/fingering.cpp
-	core/dynamic.cpp
-	core/crescendo.cpp
-	core/instrumentchange.cpp
-
-	core/syllable.cpp
-	
-	core/functionmark.cpp
 	
 	core/settings.cpp
 	core/file.cpp
 	core/tar.cpp
 	core/archive.cpp
-	core/resource.cpp
 	core/midirecorder.cpp
 	core/typesetter.cpp
 	${Canorus_Import_Srcs}
 	${Canorus_Export_Srcs}
 	${Canorus_Ctl_Srcs}
 	${Canorus_RtMidi_Srcs}
+	${Canorus_PMIDI_Srcs}
 	interface/rtmididevice.cpp
 	interface/mididevice.cpp
 	interface/playback.cpp
@@ -429,18 +438,8 @@
 	interface/plugin.cpp
 	interface/pluginaction.cpp
 	interface/pluginmanager.cpp
-#	interface/plugins_swig.cpp
+	interface/plugins_swig.cpp
 	scripting/swigpython.cpp
 	scripting/swigruby.cpp
 	${Canorus_Core_MOC_Srcs}
 )
-IF(MINGW) # Append ZLIB srcs to Swig srcs on Windows
-	SET( Canorus_Swig_Srcs ${Canorus_Swig_Srcs} ${ZLIB_Srcs} )
-ENDIF(MINGW)
-
-SET( Canorus_Scripts "scripts" ) # Official scripts shipped with Canorus.
-
-SET( Canorus_Plugins "plugins" ) # Official plug-ins shipped with Canorus.
-
-SET( Canorus_Images "ui/images" )
-

=== debian/changelog ===
canorus (0.7+dfsg+svn1256-2) unstable; urgency=low

  * Pass CPPFLAGS to CFLAGS/CXXFLAGS. CMake does not use CPPFLAGS, so
    this is needed to enable the missing hardening flags.
    Thanks to Simon Ruderich <simon@ruderich.org> (Closes: #664168)
  * Compile with -O2 to use -D_FORTIFY_SOURCE=2.
    Thanks to Simon Ruderich <simon@ruderich.org>

 -- Tobias Quathamer <toddy@debian.org>  Tue, 20 Mar 2012 10:44:32 +0100

canorus (0.7+dfsg+svn1256-1) unstable; urgency=low

  * Imported Upstream version 0.7+dfsg+svn1256
  * Refresh debian/patches
  * Use svn checkout for tarball creation
  * Switch to debhelper v9
  * Use machine-readable copyright format v1.0
  * Add git repository URL to debian/control
  * Use all hardening features in DEB_BUILD_MAINT_OPTIONS
  * Update to Standards-Version 3.9.3
  * Remove obsolete download location from watch file

 -- Tobias Quathamer <toddy@debian.org>  Wed, 14 Mar 2012 21:59:20 +0100

canorus (0.7-3) unstable; urgency=low

  * Add "-lz -lpthread" to linker flags, fixes an FTBFS with binutils-gold.
    Thanks to Ilya Barygin <barygin@gmail.com> for the patch. Closes: #554082
  * Use git-buildpackage to handle Debian patches
  * Update years in debian/copyright
  * Clean up debian/rules
  * Switch to debhelper v8
  * Update Standards-Version to 3.9.1

 -- Tobias Quathamer <toddy@debian.org>  Wed, 02 Mar 2011 10:49:02 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: canorus
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Tobias Quathamer <toddy@debian.org>
-Build-Depends: debhelper (>= 7), cmake, libasound2-dev, libqt4-dev,
+Maintainer: Tobias Quathamer <toddy@debian.org>
+Build-Depends: debhelper (>= 9), cmake, libasound2-dev, libqt4-dev,
  zlib1g-dev
-Standards-Version: 3.8.3
+Standards-Version: 3.9.3
 Homepage: http://www.canorus.org/
+Vcs-Git: git://anonscm.debian.org/users/toddy/debian/canorus.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/toddy/debian/canorus.git;a=summary
 
 Package: canorus
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# Enable verbose builds to be able to spot missing hardening flags
export VERBOSE=1

# Use all hardening features
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# CMake doesn't use CPPFLAGS, pass them to CFLAGS/CXXFLAGS to enable the
# missing (hardening) flags.
export DEB_CFLAGS_MAINT_APPEND   = $(shell dpkg-buildflags --get CPPFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)

%:
	dh $@

override_dh_auto_configure:
	cmake . -DCMAKE_INSTALL_PREFIX="/usr" -DNO_RUBY=1 -DNO_PYTHON=1

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_install:
	dh_install
	# Copy the .desktop file, upstream misses that
	cp canorus.desktop $(CURDIR)/debian/canorus/usr/share/applications/
	# Remove FreeSans.ttf, the package depends on ttf-freefont
	rm -rf $(CURDIR)/debian/canorus-data/usr/share/canorus/fonts/FreeSans.ttf

override_dh_clean:
	dh_clean
	# Preserve handwritten Makefiles during clean
	mv doc/usersguide/Makefile doc/usersguide/Makefile.upstream
	mv doc/developersguide/Makefile doc/developersguide/Makefile.upstream
	# Remove left over files from upstream (there is no distclean target)
	find -type f -name "*\.qm" | xargs rm -f
	find -type f -name "*\.cmake" | xargs rm -f
	find -type f -name "Makefile" | xargs rm -f
	find -type f -name "CMakeCache\.txt" | xargs rm -f
	find -type f -name "install_manifest\.txt" | xargs rm -f
	find -type d -name "CMakeFiles" | xargs rm -rf
	# Restore handwritten Makefiles after clean
	mv doc/usersguide/Makefile.upstream doc/usersguide/Makefile
	mv doc/developersguide/Makefile.upstream doc/developersguide/Makefile

# This target is for the creation of a new tarball which should
# be completely free according to the DFSG.
#
# As we need to create a new tarball anyway, this target can be
# used to clean up some cruft and unneeded files from upstream's
# releases.
#
# NOTE:
# Upstream currently suggests to use a checkout from SVN.
#
# NOTE:
# Make sure to *not* use the included zlib sources for linking,
# but the library provided by Debian.
#
# NOTE:
# The only free example score is examples/musicxml/Echigo-Jishi.xml,
# all other scores do not have a license.

SVN_REVISION=1251
PACKAGE_VERSION=0.7+dfsg+svn$(SVN_REVISION)
get-orig-source:
	rm -rf canorus-$(PACKAGE_VERSION)/
	mkdir canorus-$(PACKAGE_VERSION)/
	svn co -r $(SVN_REVISION) https://canorus.svn.sourceforge.net/svnroot/canorus/trunk canorus-$(PACKAGE_VERSION)/
	# This is needed to comply with DFSG
	mv canorus-$(PACKAGE_VERSION)/examples/musicxml/Echigo-Jishi.xml canorus-$(PACKAGE_VERSION)/examples/musicxml/backup
	find canorus-$(PACKAGE_VERSION)/examples/musicxml/ -type f -name "*\.xml" | xargs rm -rf
	mv canorus-$(PACKAGE_VERSION)/examples/musicxml/backup canorus-$(PACKAGE_VERSION)/examples/musicxml/Echigo-Jishi.xml
	# Remove subversion information
	find canorus-$(PACKAGE_VERSION)/ -type d -name "\.svn" | xargs rm -rf
	# Remove upstream's debian directory
	find canorus-$(PACKAGE_VERSION)/ -type d -name "debian" | xargs rm -rf
	# Remove upstream's building information
	find canorus-$(PACKAGE_VERSION)/ -type d -name "\.settings" | xargs rm -rf
	find canorus-$(PACKAGE_VERSION)/ -type d -name "\.externalToolBuilders" | xargs rm -rf
	find canorus-$(PACKAGE_VERSION)/ -type f -name "\.*project" | xargs rm -rf
	# Remove files for different platforms
	find canorus-$(PACKAGE_VERSION)/ -type d -name "windows" | xargs rm -rf
	find canorus-$(PACKAGE_VERSION)/ -type d -name "macosx" | xargs rm -rf
	# Remove zlib directory
	find canorus-$(PACKAGE_VERSION)/ -type d -name "zlib" | xargs rm -rf
	tar cjf canorus_$(PACKAGE_VERSION).orig.tar.bz2 canorus-$(PACKAGE_VERSION)/
	rm -rf canorus-$(PACKAGE_VERSION)/

# TODO: Provide a target to re-create the xpm pixmap for the menu
# This requires gm to be installed
create-menu-pixmap:
	# This does not work, the pixmaps are generated by hand with gimp
	#gm convert -resize 32x32 src/ui/images/clogosm.png debian/canorus-32x32.xpm
	#gm convert -resize 16x16 src/ui/images/clogosm.png debian/canorus-16x16.xpm

=== debian/watch ===
# Empty watch file, there's currently no download location available.
# The tarball used for this release has been created from an svn checkout.

## canorus 0.7.1~rc1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -89,6 +89,6 @@
 ADD_SUBDIRECTORY(src)
 ADD_SUBDIRECTORY(doc)
 
-# Install README, VERSION, LICENSE.GPL and other raw txt files
-INSTALL(FILES AUTHORS DEVELOPERS LICENSE.GPL NEWS README VERSION DESTINATION "${CMAKE_INSTALL_PREFIX}/${CANORUS_INSTALL_DATA_DIR}")
+# Install README, VERSION, COPYING and other raw txt files
+INSTALL(FILES AUTHORS DEVELOPERS COPYING NEWS README VERSION DESTINATION "${CMAKE_INSTALL_PREFIX}/${CANORUS_INSTALL_DATA_DIR}")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 	SET(CMAKE_BUILD_TYPE Debug)
 ENDIF(NOT CMAKE_BUILD_TYPE)
 
-SET(CMAKE_C_FLAGS_DEBUG "-O0 -g")
+SET(CMAKE_C_FLAGS_DEBUG "-O0 -g -fstack-protector-all -Wall -Werror -Wuninitialized -Wtype-limits -Wstack-protector")
 SET(CMAKE_C_FLAGS_RELEASE "-O2")
 
 SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}")
@@ -439,7 +439,3 @@
 	interface/pluginaction.cpp
 	interface/pluginmanager.cpp
 	interface/plugins_swig.cpp
-	scripting/swigpython.cpp
-	scripting/swigruby.cpp
-	${Canorus_Core_MOC_Srcs}
-)

=== doc/developersguide/Makefile ===
all:
	doxygen canorus.Doxyfile

clean:
	rm -rf html

=== doc/usersguide/Makefile ===
all: pdf qthelp

tex:
	lyx -e latex *.lyx

pdf: tex
	for i in *.tex; do pdflatex $$i && pdflatex $$i; done # Running twice for TOC

html: tex
	for i in *.tex; do htlatex $$i; done

qthelpFiles: html
	# Recreate qthelp project files (.qhp and .qhcp) - requires bash
	if [ -x /bin/bash ]; then \
		for i in *.lyx; do \
			/bin/bash createQtHelp.sh $$(echo $$i | sed 's/.lyx$$//'); \
		done \
	fi

qthelp: qthelpFiles
	for i in $$(ls *.qhcp | grep -v template.qhcp); do qcollectiongenerator $$i; done

clean: clean-tex clean-html clean-pdf clean-qthelp

clean-tex:
	rm -f *.tex images/*.eps

clean-pdf:
	rm -f *.log *.aux *.pdf

clean-html:
	rm -f *.4ct *.4tc *.aux *.css *.dvi *.html *.idv *.lg *.log *.tmp *.xref *.png *.toc

clean-qthelp:
	rm -f *.qhc *.qch

=== debian/changelog ===
canorus (0.7.1~rc1+dfsg-1) unstable; urgency=low

  * Imported Upstream version 0.7.1~rc1+dfsg.
    This fixes a crash when saving a document. Closes: #679297
  * Update get-orig-source target in debian/rules
  * Refresh patches to apply cleanly
  * New patch to initialize undefined variables
  * Add new key "Keywords" to .desktop file
  * Update Standards-Version to 3.9.4, no changes needed
  * Update debian/copyright
  * Change watch file to look for upstream tarballs again

 -- Tobias Quathamer <toddy@debian.org>  Mon, 26 Aug 2013 12:26:58 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Tobias Quathamer <toddy@debian.org>
 Build-Depends: debhelper (>= 9), cmake, libasound2-dev, libqt4-dev,
  zlib1g-dev
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://www.canorus.org/
 Vcs-Git: git://anonscm.debian.org/users/toddy/debian/canorus.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/toddy/debian/canorus.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -51,9 +51,6 @@
 # releases.
 #
 # NOTE:
-# Upstream currently suggests to use a checkout from SVN.
-#
-# NOTE:
 # Make sure to *not* use the included zlib sources for linking,
 # but the library provided by Debian.
 #
@@ -61,31 +58,29 @@
 # The only free example score is examples/musicxml/Echigo-Jishi.xml,
 # all other scores do not have a license.
 
-SVN_REVISION=1251
-PACKAGE_VERSION=0.7+dfsg+svn$(SVN_REVISION)
+UPSTREAM_VERSION=0.7.1rc1
+DEBIAN_VERSION=0.7.1~rc1+dfsg
 get-orig-source:
-	rm -rf canorus-$(PACKAGE_VERSION)/
-	mkdir canorus-$(PACKAGE_VERSION)/
-	svn co -r $(SVN_REVISION) https://canorus.svn.sourceforge.net/svnroot/canorus/trunk canorus-$(PACKAGE_VERSION)/
+	rm -rf canorus-$(DEBIAN_VERSION)/
+	tar xaf canorus-$(UPSTREAM_VERSION).tar.bz2
+	mv canorus-$(UPSTREAM_VERSION) canorus-$(DEBIAN_VERSION)
 	# This is needed to comply with DFSG
-	mv canorus-$(PACKAGE_VERSION)/examples/musicxml/Echigo-Jishi.xml canorus-$(PACKAGE_VERSION)/examples/musicxml/backup
-	find canorus-$(PACKAGE_VERSION)/examples/musicxml/ -type f -name "*\.xml" | xargs rm -rf
-	mv canorus-$(PACKAGE_VERSION)/examples/musicxml/backup canorus-$(PACKAGE_VERSION)/examples/musicxml/Echigo-Jishi.xml
-	# Remove subversion information
-	find canorus-$(PACKAGE_VERSION)/ -type d -name "\.svn" | xargs rm -rf
+	mv canorus-$(DEBIAN_VERSION)/examples/musicxml/Echigo-Jishi.xml canorus-$(DEBIAN_VERSION)/examples/musicxml/backup
+	find canorus-$(DEBIAN_VERSION)/examples/musicxml/ -type f -name "*\.xml" | xargs rm -rf
+	mv canorus-$(DEBIAN_VERSION)/examples/musicxml/backup canorus-$(DEBIAN_VERSION)/examples/musicxml/Echigo-Jishi.xml
 	# Remove upstream's debian directory
-	find canorus-$(PACKAGE_VERSION)/ -type d -name "debian" | xargs rm -rf
+	find canorus-$(DEBIAN_VERSION)/ -type d -name "debian" | xargs rm -rf
 	# Remove upstream's building information
-	find canorus-$(PACKAGE_VERSION)/ -type d -name "\.settings" | xargs rm -rf
-	find canorus-$(PACKAGE_VERSION)/ -type d -name "\.externalToolBuilders" | xargs rm -rf
-	find canorus-$(PACKAGE_VERSION)/ -type f -name "\.*project" | xargs rm -rf
+	find canorus-$(DEBIAN_VERSION)/ -type d -name "\.settings" | xargs rm -rf
+	find canorus-$(DEBIAN_VERSION)/ -type d -name "\.externalToolBuilders" | xargs rm -rf
+	find canorus-$(DEBIAN_VERSION)/ -type f -name "\.*project" | xargs rm -rf
 	# Remove files for different platforms
-	find canorus-$(PACKAGE_VERSION)/ -type d -name "windows" | xargs rm -rf
-	find canorus-$(PACKAGE_VERSION)/ -type d -name "macosx" | xargs rm -rf
+	find canorus-$(DEBIAN_VERSION)/ -type d -name "windows" | xargs rm -rf
+	find canorus-$(DEBIAN_VERSION)/ -type d -name "macosx" | xargs rm -rf
 	# Remove zlib directory
-	find canorus-$(PACKAGE_VERSION)/ -type d -name "zlib" | xargs rm -rf
-	tar cjf canorus_$(PACKAGE_VERSION).orig.tar.bz2 canorus-$(PACKAGE_VERSION)/
-	rm -rf canorus-$(PACKAGE_VERSION)/
+	find canorus-$(DEBIAN_VERSION)/ -type d -name "zlib" | xargs rm -rf
+	tar cjf canorus_$(DEBIAN_VERSION).orig.tar.bz2 canorus-$(DEBIAN_VERSION)/
+	rm -rf canorus-$(DEBIAN_VERSION)/
 
 # TODO: Provide a target to re-create the xpm pixmap for the menu
 # This requires gm to be installed

=== debian/watch ===
version=3
opts="uversionmangle=s/([a-z])/~$1/,dversionmangle=s/\+dfsg//" \
http://sf.net/canorus/canorus-(.*)\.tar\.bz2
